#!/usr/bin/python

# aa_dfetchlib.py
# -----------------------------------------------
# Tries to get Lat/long data for a specified call
# from wm7d.net using telnet interface
# April 20th, 2014 / AA7AS
# -----------------------------------------------

import telnetlib

def xlat(tlat):
	li = tlat.split('Latitude:')
	lde = li[1].split('deg')
	deg = float(lde[0])
	lmi = lde[1].split('min')
	mi = float(lmi[0])
	lsec = lmi[1].split('sec')
	se = float(lsec[0])
	orl = lsec[1].split(' ')
	orient = orl[1]
	flr = deg + (mi / 60.0) + (se / 3600.0)
	if orient != 'N':
		flr = -flr
	return flr

def xlon(tlon):
	li = tlon.split('Longitude:')
	lde = li[1].split('deg')
	deg = float(lde[0])
	lmi = lde[1].split('min')
	mi = float(lmi[0])
	lsec = lmi[1].split('sec')
	se = float(lsec[0])
	orl = lsec[1].split(' ')
	orient = orl[1]
	flr = deg + (mi / 60.0) + (se / 3600.0)
	if orient == 'W':
		flr = -flr
	return flr

def dfetch(callsign):
	try:
		tn = telnetlib.Telnet('www.wm7d.net',5000,5)
	except Exception as estring:
		return ['error',estring]
	try:
		tn.read_until("query-> ")
	except Exception as estring:
		return ['error',estring]
	try:
		tn.write(callsign+'\n')
	except Exception as estring:
		return ['error',estring]
	try:
		tn.write('exit\n')
	except Exception as estring:
		return ['error',estring]
	try:
		dump = tn.read_all()
	except Exception as estring:
		return ['error',estring]
	tlat = 'error'
	tlon = 'no lines'
	stat = 0
	ldump = dump.split('\n')
	for line in ldump:
		line = line.strip('\r')
		if line[:9] == 'Latitude:':
			tlat = line
			stat += 1
		elif line[:10] == 'Longitude:':
			tlon = line
			stat += 1
	return tlat,tlon

def lltest():
	print 'test start:\n\n'
	result = dfetch('aa7as')
	if result[0] != 'error':
		print str(xlat(result[0]))
		print str(xlon(result[1]))
	else:
		print str(result)

#lltest()
