#!/usr/bin/python

# ---------------------------------------
# Group list and mapping system
# - - - - - - - - - - - - - - - - - - - -
# Version: 1.0
# Written by: AA7AS, Ben
# April 18th, 2014 -- May 15th, 2014
# Tab spacing: 4
# Sharing: Mixed PD / Apache license
# - - - - - - - - - - - - - - - - - - - -
# The AA7AS code here is released public
# domain. Some of the Java is Apache
# licensed, see below for specifics and
# copyright information.
# ---------------------------------------

# Standard Python libraries we use
# --------------------------------
import sys, os, cgi, sqlite3

# Custom AA7AS libraries
# ----------------------
from aa_tablelib import *
from aa_rangebear import *
from aa_dfetchlib import *
from aa_configlib import *

# configuration:
# ==============

cfile = 'arptcfg.txt'
cfg = getconfig(cfile)

if 0:	# Diganostic for config:
	for c in cfg:
		print '"'+c+'"'+'="'+cfg[c]+'"'
	raise SystemExit

# If you'd like a little extra speed when the webserver
# loads the script, you can precompile the script at the
# command line once it's configured the way you want it.
# This process strips out the comments and creates byte
# code, preventing python from having to recreate it
# every time the script is loaded, and allowing the
# web server to load the thing a little faster. Execution
# time, however, will not change.
# ------------------------------------------------------
# python -m compileall areport.py
# ------------------------------------------------------

# CONFIGURATION:
# --------------

password   = cfg['password']
validation = cfg['validation']
lmip       = cfg['lmip']
instr      = cfg['instr']
mapsize    = cfg['mapsize']
dbname     = cfg['dbname']
cicolor    = cfg['cicolor']
prcolor    = cfg['prcolor']
sweight    = cfg['sweight']
presetname = cfg['presetname']
chomelat   = cfg['chomelat']
chomelon   = cfg['chomelon']

# END OF CONFIGURATION
# --------------------

# Fooling with anything below here voids the nonexistent warranty. :)
# -------------------------------------------------------------------
# -------------------------------------------------------------------
# -------------------------------------------------------------------
# -------------------------------------------------------------------


# Here's the magic that gets us all the data from the form:
# ---------------------------------------------------------
form = cgi.FieldStorage()

tstr = ''
thediag = ''

# This bit of opacity extracts the name of our script:
# I regret to say that this might not work under Windows
# due to the use of reverse slashes in file names, but
# I just don't know what windows web servers and python
# negotiate argv[0] name strings into. If it looks like
# osx or linux, it'll work. If it's got backslashes...
# not so much. But the mod should be easy: replace that
# ('/'), the split argument, with a backslash ('\\')
# Since I don't know, you have to hand code the script
# name (presetname) if you're not running under linux. The
# script is supplied as 'areport.py' and this initially
# assumes you've kept that name. No? Then you need to
# change presetnmame, above, if you're not running under
# linux.
# ------------------------------------------------------
if sys.platform.startswith('linux'):
	rpt = ((str(sys.argv[0])[:-3]).split('/'))[-1] # actually figure out name
else:
	rpt = presetname

# Mumbo-jumbo to wake up browser to fact that page is coming
# ----------------------------------------------------------
hdr = "Content-type: text/html\n\n"

msw = 1
twocols = 1
showll = 1
overlat = ''
overlon = ''
overcall = ''

try:
	remote = os.environ['REMOTE_ADDR'];
except:
	remote = '127.0.0.1' # if user has something obfuscating data

# Check for list maintainer. Hardly foolproof, but
# enough for this. Assumes your  browser sends, and
# your firewall doesn't block, the REMOTE_ADDR data
# chunklette. If it does, you need to fix that.
# ---------------------------------------------------
enable = 0
needpassword = 1
if remote == lmip: # ok, 1st test passed: looks like list maintainer
	enable = 1

pwpage = """
<HTML>
<HEAD>
<TITLE>Enter Password</TITLE>
</HEAD>
<BODY>
<FORM ACTION="/cgi-bin/[RPT].py" METHOD="POST">
Enter&nbsp;Password:&nbsp;<INPUT TYPE="PASSWORD" NAME="MPW" VALUE="">
</FORM>
</BODY>
</HTML>
"""
pwpage = pwpage.replace('[RPT]',rpt)

# perhaps we came in from the password page. If so:
# -------------------------------------------------
vreplace = ''
try:
	formvalue = qsafe(form['MPW'].value)
except:
	pass # not from PW page, never mind
else: # we *did* come from PW page:
	if formvalue == password: # special case first entry
		vreplace = validation # if PW entered, allow one use

# Now we want to make sure that the password has been entered if
# we think this is the list maintainer:
# --------------------------------------------------------------
if enable == 1: # we think we're the list maintainer
	if vreplace != validation: # if not special case from PW page
		try:
			formvalue = form['VALIDATION'].value # then validate from form
		except:	# whoops! No validation. Need password
			enable = 0
			sys.stdout.write(hdr)
			sys.stdout.write(pwpage)
			sys.stdout.flush()
			raise SystemExit
		else:
			if formvalue != validation: # if not validated, drop enable flag
				enable = 0
			else:
				vreplace = validation # ok, we're up

# at this point, if this is the list maintainer, either
# vreplace is up from the PW match, or because we caught
# the proper validation from the main form. Verify this:
# ------------------------------------------------------

# ensure we drop enable if not validated
# --------------------------------------
if vreplace != validation:
	enable = 0

# Now we know who we are, and what we can do. :)
# ----------------------------------------------

# This chunk is the label  class for javascript
# ---------------------------------------------

lclass = """
<SCRIPT>
/**
 * @name MarkerWithLabel for V3
 * @version 1.0.1 [September 17, 2010]
 * @author Gary Little (inspired by code from Marc Ridey of Google).
 * @copyright Copyright 2010 Gary Little [gary at luxcentral.com]
 * @fileoverview MarkerWithLabel extends the Google Maps JavaScript API V3
 *  <code>google.maps.Marker</code> class.
 *  <p>
 *  MarkerWithLabel allows you to define markers with associated labels. As you would expect,
 *  if the marker is draggable, so too will be the label. In addition, a marker with a label
 *  responds to all mouse events in the same manner as a regular marker. It also fires mouse
 *  events and "property changed" events just as a regular marker would.
 */

/*!
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*jslint browser:true */
/*global document,google */

/**
 * This constructor creates a label and associates it with a marker.
 * It is for the private use of the MarkerWithLabel class.
 * @constructor
 * @param {Marker} marker The marker with which the label is to be associated.
 * @private
 */
function MarkerLabel_(marker) {
  this.marker_ = marker;

  this.labelDiv_ = document.createElement("div");
  this.labelDiv_.style.cssText = "position: absolute; overflow: hidden;";

  // Set up the DIV for handling mouse events in the label. This DIV forms a transparent veil
  // in the "overlayMouseTarget" pane, a veil that covers just the label. This is done so that
  // events can be captured even if the label is in the shadow of a google.maps.InfoWindow.
  // Code is included here to ensure the veil is always exactly the same size as the label.
  this.eventDiv_ = document.createElement("div");
  this.eventDiv_.style.cssText = this.labelDiv_.style.cssText;
}

// MarkerLabel_ inherits from OverlayView:
MarkerLabel_.prototype = new google.maps.OverlayView();

/**
 * Adds the DIV representing the label to the DOM. This method is called
 * automatically when the marker's <code>setMap</code> method is called.
 * @private
 */
MarkerLabel_.prototype.onAdd = function () {
  var me = this;
  var cMouseIsDown = false;
  var cDraggingInProgress = false;
  var cSavedPosition;
  var cSavedZIndex;
  var cLatOffset, cLngOffset;
  var cIgnoreClick;

  // Stops all processing of an event.
  //
  var cAbortEvent = function (e) {
    if (e.preventDefault) {
      e.preventDefault();
    }
    e.cancelBubble = true;
    if (e.stopPropagation) {
      e.stopPropagation();
    }
  };

  this.getPanes().overlayImage.appendChild(this.labelDiv_);
  this.getPanes().overlayMouseTarget.appendChild(this.eventDiv_);

  this.listeners_ = [
    google.maps.event.addDomListener(document, "mouseup", function (mEvent) {
      if (cDraggingInProgress) {
        mEvent.latLng = cSavedPosition;
        cIgnoreClick = true; // Set flag to ignore the click event reported after a label drag
        google.maps.event.trigger(me.marker_, "dragend", mEvent);
      }
      cMouseIsDown = false;
      google.maps.event.trigger(me.marker_, "mouseup", mEvent);
    }),
    google.maps.event.addListener(me.marker_.getMap(), "mousemove", function (mEvent) {
      if (cMouseIsDown && me.marker_.getDraggable()) {
        // Change the reported location from the mouse position to the marker position:
        mEvent.latLng = new google.maps.LatLng(mEvent.latLng.lat() - cLatOffset, mEvent.latLng.lng() - cLngOffset);
        cSavedPosition = mEvent.latLng;
        if (cDraggingInProgress) {
          google.maps.event.trigger(me.marker_, "drag", mEvent);
        } else {
          // Calculate offsets from the click point to the marker position:
          cLatOffset = mEvent.latLng.lat() - me.marker_.getPosition().lat();
          cLngOffset = mEvent.latLng.lng() - me.marker_.getPosition().lng();
          google.maps.event.trigger(me.marker_, "dragstart", mEvent);
        }
      }
    }),
    google.maps.event.addDomListener(this.eventDiv_, "mouseover", function (e) {
      me.eventDiv_.style.cursor = "pointer";
      google.maps.event.trigger(me.marker_, "mouseover", e);
    }),
    google.maps.event.addDomListener(this.eventDiv_, "mouseout", function (e) {
      me.eventDiv_.style.cursor = me.marker_.getCursor();
      google.maps.event.trigger(me.marker_, "mouseout", e);
    }),
    google.maps.event.addDomListener(this.eventDiv_, "click", function (e) {
      if (cIgnoreClick) { // Ignore the click reported when a label drag ends
        cIgnoreClick = false;
      } else {
        cAbortEvent(e); // Prevent click from being passed on to map
        google.maps.event.trigger(me.marker_, "click", e);
      }
    }),
    google.maps.event.addDomListener(this.eventDiv_, "dblclick", function (e) {
      cAbortEvent(e); // Prevent map zoom when double-clicking on a label
      google.maps.event.trigger(me.marker_, "dblclick", e);
    }),
    google.maps.event.addDomListener(this.eventDiv_, "mousedown", function (e) {
      cMouseIsDown = true;
      cDraggingInProgress = false;
      cLatOffset = 0;
      cLngOffset = 0;
      cAbortEvent(e); // Prevent map pan when starting a drag on a label
      google.maps.event.trigger(me.marker_, "mousedown", e);
    }),
    google.maps.event.addListener(this.marker_, "dragstart", function (mEvent) {
      cDraggingInProgress = true;
      cSavedZIndex = me.marker_.getZIndex();
    }),
    google.maps.event.addListener(this.marker_, "drag", function (mEvent) {
      me.marker_.setPosition(mEvent.latLng);
      me.marker_.setZIndex(1000000); // Moves the marker to the foreground during a drag
    }),
    google.maps.event.addListener(this.marker_, "dragend", function (mEvent) {
      cDraggingInProgress = false;
      me.marker_.setZIndex(cSavedZIndex);
    }),
    google.maps.event.addListener(this.marker_, "position_changed", function () {
      me.setPosition();
    }),
    google.maps.event.addListener(this.marker_, "zindex_changed", function () {
      me.setZIndex();
    }),
    google.maps.event.addListener(this.marker_, "visible_changed", function () {
      me.setVisible();
    }),
    google.maps.event.addListener(this.marker_, "labelvisible_changed", function () {
      me.setVisible();
    }),
    google.maps.event.addListener(this.marker_, "title_changed", function () {
      me.setTitle();
    }),
    google.maps.event.addListener(this.marker_, "labelcontent_changed", function () {
      me.setContent();
    }),
    google.maps.event.addListener(this.marker_, "labelanchor_changed", function () {
      me.setAnchor();
    }),
    google.maps.event.addListener(this.marker_, "labelclass_changed", function () {
      me.setStyles();
    }),
    google.maps.event.addListener(this.marker_, "labelstyle_changed", function () {
      me.setStyles();
    })
  ];
};

/**
 * Removes the DIV for the label from the DOM. It also removes all event handlers.
 * This method is called automatically when the marker's <code>setMap(null)</code>
 * method is called.
 * @private
 */
MarkerLabel_.prototype.onRemove = function () {
  var i;
  this.labelDiv_.parentNode.removeChild(this.labelDiv_);
  this.eventDiv_.parentNode.removeChild(this.eventDiv_);

  // Remove event listeners:
  for (i = 0; i < this.listeners_.length; i++) {
    google.maps.event.removeListener(this.listeners_[i]);
  }
};

/**
 * Draws the label on the map.
 * @private
 */
MarkerLabel_.prototype.draw = function () {
  this.setContent();
  this.setTitle();
  this.setStyles();
};

/**
 * Sets the content of the label.
 * The content can be plain text or an HTML DOM node.
 * @private
 */
MarkerLabel_.prototype.setContent = function () {
  var content = this.marker_.get("labelContent");
  if (typeof content.nodeType === "undefined") {
    this.labelDiv_.innerHTML = content;
    this.eventDiv_.innerHTML = this.labelDiv_.innerHTML;
  } else {
    this.labelDiv_.appendChild(content);
    content = content.cloneNode(true);
    this.eventDiv_.appendChild(content);
  }
};

/**
 * Sets the content of the tool tip for the label. It is
 * always set to be the same as for the marker itself.
 * @private
 */
MarkerLabel_.prototype.setTitle = function () {
  this.eventDiv_.title = this.marker_.getTitle() || "";
};

/**
 * Sets the style of the label by setting the style sheet and applying
 * other specific styles requested.
 * @private
 */
MarkerLabel_.prototype.setStyles = function () {
  var i, labelStyle;

  // Apply style values from the style sheet defined in the labelClass parameter:
  this.labelDiv_.className = this.marker_.get("labelClass");
  this.eventDiv_.className = this.labelDiv_.className;

  // Clear existing inline style values:
  this.labelDiv_.style.cssText = "";
  this.eventDiv_.style.cssText = "";
  // Apply style values defined in the labelStyle parameter:
  labelStyle = this.marker_.get("labelStyle");
  for (i in labelStyle) {
    if (labelStyle.hasOwnProperty(i)) {
      this.labelDiv_.style[i] = labelStyle[i];
      this.eventDiv_.style[i] = labelStyle[i];
    }
  }
  this.setMandatoryStyles();
};

/**
 * Sets the mandatory styles to the DIV representing the label as well as to the
 * associated event DIV. This includes setting the DIV position, zIndex, and visibility.
 * @private
 */
MarkerLabel_.prototype.setMandatoryStyles = function () {
  this.labelDiv_.style.position = "absolute";
  this.labelDiv_.style.overflow = "hidden";
  // Make sure the opacity setting causes the desired effect on MSIE:
  if (typeof this.labelDiv_.style.opacity !== "undefined") {
    this.labelDiv_.style.filter = "alpha(opacity=" + (this.labelDiv_.style.opacity * 100) + ")";
  }

  this.eventDiv_.style.position = this.labelDiv_.style.position;
  this.eventDiv_.style.overflow = this.labelDiv_.style.overflow;
  this.eventDiv_.style.opacity = 0.01; // Don't use 0; DIV won't be clickable on MSIE
  this.eventDiv_.style.filter = "alpha(opacity=1)"; // For MSIE
  
  this.setAnchor();
  this.setPosition(); // This also updates zIndex, if necessary.
  this.setVisible();
};

/**
 * Sets the anchor point of the label.
 * @private
 */
MarkerLabel_.prototype.setAnchor = function () {
  var anchor = this.marker_.get("labelAnchor");
  this.labelDiv_.style.marginLeft = -anchor.x + "px";
  this.labelDiv_.style.marginTop = -anchor.y + "px";
  this.eventDiv_.style.marginLeft = -anchor.x + "px";
  this.eventDiv_.style.marginTop = -anchor.y + "px";
};

/**
 * Sets the position of the label. The zIndex is also updated, if necessary.
 * @private
 */
MarkerLabel_.prototype.setPosition = function () {
  var position = this.getProjection().fromLatLngToDivPixel(this.marker_.getPosition());
  
  this.labelDiv_.style.left = position.x + "px";
  this.labelDiv_.style.top = position.y + "px";
  this.eventDiv_.style.left = this.labelDiv_.style.left;
  this.eventDiv_.style.top = this.labelDiv_.style.top;

  this.setZIndex();
};

/**
 * Sets the zIndex of the label. If the marker's zIndex property has not been defined, the zIndex
 * of the label is set to the vertical coordinate of the label. This is in keeping with the default
 * stacking order for Google Maps: markers to the south are in front of markers to the north.
 * @private
 */
MarkerLabel_.prototype.setZIndex = function () {
  var zAdjust = (this.marker_.get("labelInBackground") ? -1 : +1);
  if (typeof this.marker_.getZIndex() === "undefined") {
    this.labelDiv_.style.zIndex = parseInt(this.labelDiv_.style.top, 10) + zAdjust;
    this.eventDiv_.style.zIndex = this.labelDiv_.style.zIndex;
  } else {
    this.labelDiv_.style.zIndex = this.marker_.getZIndex() + zAdjust;
    this.eventDiv_.style.zIndex = this.labelDiv_.style.zIndex;
  }
};

/**
 * Sets the visibility of the label. The label is visible only if the marker itself is
 * visible (i.e., its visible property is true) and the labelVisible property is true.
 * modified -- AA7AS
 * @private
 */
MarkerLabel_.prototype.setVisible = function () {
  if (this.marker_.get("labelVisible")) {
    this.labelDiv_.style.display = this.marker_.getVisible() ? "block" : "none";
  } else {
    this.labelDiv_.style.display = "none";
  }
  this.eventDiv_.style.display = this.labelDiv_.style.display;
/**
 * override with always visible (AA7AS):
 */
  this.labelDiv_.style.display = "block";
};

/**
 * @name MarkerWithLabelOptions
 * @class This class represents the optional parameter passed to the {@link MarkerWithLabel} constructor.
 *  The properties available are the same as for <code>google.maps.Marker</code> with the addition
 *  of the properties listed below. To change any of these additional properties after the labeled
 *  marker has been created, call <code>google.maps.Marker.set(propertyName, propertyValue)</code>.
 *  <p>
 *  When any of these properties changes, a property changed event is fired. The names of these
 *  events are derived from the name of the property and are of the form <code>propertyname_changed</code>.
 *  For example, if the content of the label changes, a <code>labelcontent_changed</code> event
 *  is fired.
 *  <p>
 * @property {string|Node} [labelContent] The content of the label (plain text or an HTML DOM node).
 * @property {Point} [labelAnchor] By default, a label is drawn with its anchor point at (0,0) so
 *  that its top left corner is positioned at the anchor point of the associated marker. Use this
 *  property to change the anchor point of the label. For example, to center a 50px-wide label
 *  beneath a marker, specify a <code>labelAnchor</code> of <code>google.maps.Point(25, 0)</code>.
 *  (Note: x-values increase to the right and y-values increase to the bottom.)
 * @property {string} [labelClass] The name of the CSS class defining the styles for the label.
 *  Note that style values for <code>position</code>, <code>overflow</code>, <code>top</code>,
 *  <code>left</code>, <code>zIndex</code>, <code>display</code>, <code>marginLeft</code>, and
 *  <code>marginTop</code> are ignored; these styles are for internal use only.
 * @property {Object} [labelStyle] An object literal whose properties define specific CSS
 *  style values to be applied to the label. Style values defined here override those that may
 *  be defined in the <code>labelClass</code> style sheet. If this property is changed after the
 *  label has been created, all previously set styles (except those defined in the style sheet)
 *  are removed from the label before the new style values are applied.
 *  Note that style values for <code>position</code>, <code>overflow</code>, <code>top</code>,
 *  <code>left</code>, <code>zIndex</code>, <code>display</code>, <code>marginLeft</code>, and
 *  <code>marginTop</code> are ignored; these styles are for internal use only.
 * @property {boolean} [labelInBackground] A flag indicating whether a label that overlaps its
 *  associated marker should appear in the background (i.e., in a plane below the marker).
 *  The default is <code>false</code>, which causes the label to appear in the foreground.
 * @property {boolean} [labelVisible] A flag indicating whether the label is to be visible.
 *  The default is <code>true</code>. Note that even if <code>labelVisible</code> is
 *  <code>true</code>, the label will <i>not</i> be visible unless the associated marker is also
 *  visible (i.e., unless the marker's <code>visible</code> property is <code>true</code>).
 */
/**
 * Creates a MarkerWithLabel with the options specified in {@link MarkerWithLabelOptions}.
 * @constructor
 * @param {MarkerWithLabelOptions} [opt_options] The optional parameters.
 */
function MarkerWithLabel(opt_options) {
  opt_options = opt_options || {};
  opt_options.labelContent = opt_options.labelContent || "";
  opt_options.labelAnchor = opt_options.labelAnchor || new google.maps.Point(0, 0);
  opt_options.labelClass = opt_options.labelClass || "markerLabels";
  opt_options.labelStyle = opt_options.labelStyle || {};
  opt_options.labelInBackground = opt_options.labelInBackground || false;
  if (typeof opt_options.labelVisible === "undefined") {
    opt_options.labelVisible = true;
  }

  this.label = new MarkerLabel_(this); // Bind the label to the marker

  // Call the parent constructor. It calls Marker.setValues to initialize, so all
  // the new parameters are conveniently saved and can be accessed with get/set.
  // Marker.set triggers a property changed event (called "propertyname_changed")
  // that the marker label listens for in order to react to state changes.
  google.maps.Marker.apply(this, arguments);
}

// MarkerWithLabel inherits from <code>Marker</code>:
MarkerWithLabel.prototype = new google.maps.Marker();

MarkerWithLabel.prototype.setMap = function (theMap) {
  // Call the inherited function...
  google.maps.Marker.prototype.setMap.apply(this, arguments);

  // ... then deal with the label:
  this.label.setMap(theMap);
};
</SCRIPT>
"""

# This chunk is the javascript that configures the Google map:
# ------------------------------------------------------------
thejs = """
<meta name="viewport" content="initial-scale=1.0, user-scalable=no">
<meta charset="utf-8">
<title>Complex icons</title>
<style>
   html, body, #map-canvas {
      height: 100%;
      margin: 0px;
      padding: 0px
}
</style>
<script src="https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false"></script>
[LABELCLASS]
<script>
// Note that the anchor is set to
// (0,32) to correspond to the base of the flagpole.

function initialize() {
  var mapOptions = {
      zoom: 4,
      center: new google.maps.LatLng([CENTLAT], [CENTLONG])
 }
 var map = new google.maps.Map(document.getElementById('map-canvas'),
                               mapOptions);

var bounds = new google.maps.LatLngBounds();

[LINEBLOCK]

bounds = setMarkers(map, hamz, bounds);

var increasePercentage = .05;

var pointNorthEast = bounds.getNorthEast();
var pointSouthWest = bounds.getSouthWest();

var latAdjustment = ((pointNorthEast.lat() - pointSouthWest.lat()) * increasePercentage);
var lngAdjustment = ((pointNorthEast.lng() - pointSouthWest.lng()) * increasePercentage);

var newPointNorthEast = new google.maps.LatLng(pointNorthEast.lat() + latAdjustment, pointNorthEast.lng() + lngAdjustment);
var newPointSouthWest = new google.maps.LatLng(pointSouthWest.lat() - latAdjustment, pointSouthWest.lng() - lngAdjustment);

bounds2 = new google.maps.LatLngBounds();

bounds2.extend(newPointNorthEast);
bounds2.extend(newPointSouthWest);

map.fitBounds(bounds2);

}
/**
 * Data for the markers consisting of a name, a LatLng and a zIndex for
 * the order in which these markers should display on top of each
 * other.
*/

var hamz = [
[POINTLIST]
];
  function setMarkers(map, locations, bounds) {

// Add markers to the map

// Marker sizes are expressed as a Size of X,Y
// where the origin of the image (0,0) is located
// in the top left of the image.

// Origins, anchor positions and coordinates of the marker
// increase in the X direction to the right and in
// the Y direction down.

  var image = {
  url: '/images/beachflag.png',
  // This marker is 20 pixels wide by 32 pixels tall.
  size: new google.maps.Size(20, 32),
  // The origin for this image is 0,0.
  origin: new google.maps.Point(0,0),
  // The anchor for this image is the base of the flagpole at 0,32.
  anchor: new google.maps.Point(0, 32)
};

// Shapes define the clickable region of the icon.
// The type defines an HTML &lt;area&gt; element 'poly' which
// traces out a polygon as a series of X,Y points. The final
// coordinate closes the poly by connecting to the first
// coordinate.

var shape = {
  coord: [1, 1, 1, 20, 18, 20, 18 , 1],
  type: 'poly'
  };

	for (var i = 0; i < locations.length; i++) {
		var beach = locations[i];
		var myLatLng = new google.maps.LatLng(beach[1], beach[2]);
		var marker = new google.maps.Marker({
			position: myLatLng,
			map: map,
			icon: image,
			shape: shape,
			title: beach[0],
			zIndex: beach[3]
		});
		bounds.extend(marker.position);
	}
	return bounds;
}

  google.maps.event.addDomListener(window, 'load', initialize);

</script>
"""

thejs = thejs.replace("[LABELCLASS]",lclass)
#thejs = thejs.replace("[LABELCLASS]",'')

# This is the template for the HTML page
# --------------------------------------
page = """<HTML>
<HEAD>
<TITLE>Group Reference</TITLE>
[THESTYLES]
[THEJS]
</HEAD>
<BODY>
<CENTER>
<FORM ACTION="/cgi-bin/[RPT].py" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="VALIDATION" VALUE="[VALIDATION]">
<a href="[INSTR]">Instructions Here</a>
<table border bgcolor="#ddffff">
<tr>
<td colspan=5>Latitude: <INPUT TYPE="text" NAME="hlat" VALUE="[HLAT]">
Longitude:<INPUT TYPE="text" NAME="hlon" VALUE="[HLON]">
<INPUT TYPE="CHECKBOX" NAME="km" VALUE="usekm"[KMMI]>&nbsp;Km
<INPUT TYPE="CHECKBOX" NAME="tc" VALUE="onecol"[ONEC]>&nbsp;Cols
<INPUT TYPE="CHECKBOX" NAME="showll" VALUE="showit"[SHOWLL]>&nbsp;LL
<INPUT TYPE="CHECKBOX" NAME="showlabs" VALUE="arf"[SHOWLABS]>&nbsp;labels
<INPUT TYPE="CHECKBOX" NAME="signins" VALUE="floatup"[SHOWFU]>&nbsp;float
<INPUT TYPE="submit" NAME="clear" VALUE="CLR ck">
<INPUT TYPE="submit" NAME="nonn" VALUE="CLR #">
</td>
<td bgcolor="#88ff88" align="center"><INPUT TYPE="submit" NAME="kickme" VALUE="Regenerate"></td>
</tr>
<tr>
<td><INPUT TYPE="radio" NAME="sortby" VALUE="byname"[CBYNAME]>Sort by Name</td>
<td><INPUT TYPE="radio" NAME="sortby" VALUE="bynumber"[CBYNUMBER]>Sort by number</td>
<td><INPUT TYPE="radio" NAME="sortby" VALUE="bycall"[CBYCALL]>Sort by Call</td>
<td><INPUT TYPE="radio" NAME="sortby" VALUE="bylocation"[CBYLOCATION]>Sort by Location</td>
<td><INPUT TYPE="radio" NAME="sortby" VALUE="bydistance"[CBYDISTANCE]>Sort by Distance</td>
<td><INPUT TYPE="radio" NAME="sortby" VALUE="byheading"[CBYHEADING]>Sort by Bearing</td>
</tr>
[GOODIES]
</table>
<br>
[REPLACE]
</FORM>
[DIAG]
<table border width = [MAPSIZE] height = [MAPSIZE]>
<tr>
<td><div id="map-canvas"></div></td>
</tr>
</table>
Group list and mapping system v1.0 -- Python, Javascript, DB &amp; HTML by <a href="http://fyngyrz.com/">AA7AS</a><br>
with label Javascript by Gary Little (modified by <a href="http://fyngyrz.com/">AA7AS</a>)
</CENTER>
</BODY>
</HTML>
"""

thestyles = """
<STYLE>
.labels {
   color: black;
   background-color: white;
   font-family: "Lucida Grande", "Arial", sans-serif;
   font-size: 10px;
   font-weight: bold;
   text-align: center;
   border: 2px solid black;
   white-space: nowrap;
}
</STYLE>
"""

themarkerXref = """
var marker = new MarkerWithLabel({
   position: homeLatLng,
   draggable: true,
   map: map,
   labelContent: "$425K",
   labelAnchor: new google.maps.Point(22, 0),
   labelClass: "labels", // the CSS class for the label
   labelStyle: {opacity: 0.75}
});
"""

themarker = """
var marker = new MarkerWithLabel({
   position: [HOMELATLNG],
   draggable: true,
   visible: false,
   map: map,
   labelContent: "[LABELCONTENT]",
   labelAnchor: new google.maps.Point(22, 0),
   labelClass: "labels", // the CSS class for the label
   labelStyle: {opacity: 1.0}
});
"""

# Begin to configure the page template
# ------------------------------------
page = page.replace('[RPT]',rpt)
page = page.replace('[INSTR]',instr)
page = page.replace('[THESTYLES]',thestyles)
page = page.replace('[THEJS]',thejs)
page = page.replace('[MAPSIZE]',str(mapsize))

# Some features only show for the list maintainer
# -----------------------------------------------
goodies = ''
if enable == 1:
	goodies = """
<tr>
<td>Call: <INPUT TYPE="text" NAME="callsign" VALUE="[FILLMECAL]"></td>
<td>Name: <INPUT TYPE="text" NAME="name" VALUE=""></td>
<td>Loca: <INPUT TYPE="text" NAME="location" VALUE=""></td>
<td>Lati: <INPUT TYPE="text" NAME="latitude" VALUE="[FILLMELAT]"></td>
<td>Long: <INPUT TYPE="text" NAME="longitude" VALUE="[FILLMELON]"></td>
<td bgcolor="#ff8888" align="center">
<INPUT TYPE="submit" NAME="newmember" VALUE="Add / Update">
<INPUT TYPE="submit" NAME="getll" VALUE="Geo">
</td>
</tr>
"""
page = page.replace('[GOODIES]',goodies)

# determine sorting preference
# ----------------------------
try:
	mm = form['sortby'].value
except:
	mm = ''

cbt = ''
cbi = ''
cbs = ''
cbp = ''
cbx = ''
cbv = ''
sbyh = 0
sbyd = 0
sbyn = 0

cc1=cc2=cc3=cc4=cc5=cc6=''

if mm == 'byname':
	cbi = ' CHECKED'
	sql = "SELECT name,callsign,location,lat,lon FROM members ORDER BY name ASC"
	cc1 = ' bgcolor="#ffdddd"'

elif mm == 'bylocation':
	cbs = ' CHECKED'
	sql = "SELECT name,callsign,location,lat,lon FROM members ORDER BY location ASC"
	cc3 = ' bgcolor="#ffdddd"'

elif mm == 'byheading':
	cbp = ' CHECKED'
	sql = "SELECT name,callsign,location,lat,lon FROM members ORDER BY location ASC"
	sbyh = 1
	cc5 = ' bgcolor="#ffdddd"'

elif mm == 'bydistance':
	cbx = ' CHECKED'
	sql = "SELECT name,callsign,location,lat,lon FROM members ORDER BY location ASC"
	sbyd = 1
	cc4 = ' bgcolor="#ffdddd"'

elif mm == 'bynumber':
	cbv = ' CHECKED'
	sql = "SELECT name,callsign,location,lat,lon FROM members ORDER BY location ASC"
	sbyn = 1
	cc6 = ' bgcolor="#ffdddd"'

else: # bycallsign
	cbt = ' CHECKED'
	sql = "SELECT name,callsign,location,lat,lon FROM members ORDER BY callsign ASC"
	cc2 = ' bgcolor="#ffdddd"'

totwstarts = 0
totostarts = 0
totustarts = 0

try:
	formvalue = form['getll'].value # special submit button
except:
	pass
else:
	if formvalue == 'Geo':
		try:
			formvalue = qsafe(str(form['callsign'].value))
		except:
			formvalue = ''
		else:
			thecall = formvalue.lower()
			overcall = thecall
			result = dfetch(thecall)
			overlat = result[0]
			overlon = result[1]
			if overlat == 'error':
				overlat = ''
				overlon = ''
			else:
				try:
					overlat = str(xlat(overlat))
					overlon = str(xlon(overlon))
				except:
					overlat = ''
					overlon = ''

# See if list maintainer has supplied anything
# --------------------------------------------
try:
	formvalue = form['newmember'].value # special submit button
except:
	pass
else:
	try:
		formvalue = qsafe(str(form['callsign'].value))
	except:
		formvalue = ''
	thecall = formvalue.lower()

	try:
		formvalue = qsafe(str(form['name'].value))
	except:
		formvalue = ''
	thename = formvalue

	try:
		formvalue = qsafe(str(form['location'].value))
	except:
		formvalue = ''
	thelocation = formvalue

	try:
		formvalue = qsafe(str(form['latitude'].value))
	except:
		formvalue = ''
	thelat = formvalue

	try:
		formvalue = qsafe(str(form['longitude'].value))
	except:
		formvalue = ''
	thelon = formvalue

# Take supplied data and add, update or delete a list entry
# -------------------------------------------------------------
# just existing callsign == DELETE
# existing callsign + any field(s) is update that/those field(s)
# new callsign + any fields = create new list entry
# --------------------------------------------------------------
	if 1:
		try:
			conn = sqlite3.connect(dbname)
		except:
			tstr += 'sqlite3.connect(... exception'
		else:
			try:
				c = conn.cursor()
			except Exception as inst:
				tstr += 'conn.cursor() exception'
			else:
				cmd = "SELECT callsign FROM members WHERE callsign = '"+thecall+"'"
				callcount = 0
				try:
					for row in c.execute(cmd):
						callcount += 1
				except:
					pass
				if callcount == 0:
					signnn = 'INSERT'
					cmd = "INSERT INTO members (name,callsign,location,lat,lon) VALUES ('"+thename+"','"+thecall+"','"+thelocation+"','"+thelat+"','"+thelon+"')"
				else:
					if thename=='' and thelocation=='' and thelat=='' and thelon == '':
						signn = 'DELETE'
						cmd = "DELETE FROM members WHERE callsign = '"+thecall.lower()+"'"
					else:
						signn = 'UPDATE'
						cmd = "UPDATE members SET "
						val = 0
						if thename != '':
							val = 1
							cmd += "name='"+thename+"'"
						if thecall != '':
							if val == 1:
								cmd += ','
							val=1
							cmd +="callsign='"+thecall+"'"
						if thelocation != '':
							if val == 1:
								cmd += ','
							val=1
							cmd += "location='"+thelocation+"'"
						if thelat != '':
							if val == 1:
								cmd += ','
							val=1
							cmd += "lat='"+thelat+"'"
						if thelon != '':
							if val == 1:
								cmd += ','
							val=1
							cmd +="lon='"+thelon+"'"
						cmd += " WHERE callsign = '"+thecall+"'"
						if val == 0:
							cmd = "SELECT name FROM members WHERE callsign='AA7AS'"
				try:
					c.execute(cmd)
				except:
					tstr += 'c.execute('+signn+'... exception'
				else:
					try:
						conn.commit()
					except:
						tstr += 'conn.commit() of '+signn+'... exception'
				c.close()

# Collect more info about how to display
# --------------------------------------
showlabs = 0
try:
	formvalue = str(form['showlabs'].value)
except:
	formvalue = ''
else:
	if formvalue == 'arf':
		showlabs = 1

floatup = 0
try:
	formvalue = str(form['signins'].value)
except:
	formvalue = ''
else:
	if formvalue == 'floatup':
		floatup = 1

globalnn = 0
try:
	formvalue = str(form['nonn'].value)
except:
	formvalue = ''
else:
	globalnn = 1

globalclear = 0
try:
	formvalue = str(form['clear'].value)
except:
	formvalue = ''
else:
	globalclear = 1

try:
	formvalue = qsafe(str(float(form['hlat'].value)))
except:
	formvalue = chomelat
homelat = formvalue

try:
	formvalue = qsafe(str(float(form['hlon'].value)))
except:
	formvalue = chomelon
homelon = formvalue

# This is a special entry, end user has clicked a call in the list
# so we want to override the home lat/long values with this call.
# ----------------------------------------------------------------
try:
	formvalue = qsafe(str(form['fromcall'].value))
except:
	formvalue = ''
else:
	fromcall = formvalue.lower()
	try:
		conn = sqlite3.connect(dbname)
	except:
		tstr += 'sqlite3.connect(... lookup exception'
	else:
		try:
			c = conn.cursor()
		except:
			tstr += 'conn.cursor() exception'
		else:
			try:
				for row in c.execute("SELECT lat,lon FROM members WHERE callsign='"+fromcall+"'"):
					nlat = str(row[0])
					nlon = str(row[1])
			except:
				pass
			else:
				homelat = nlat
				homelon = nlon
			c.close()

try:
	formvalue = form['tc'].value
except:
	formvalue = ''
if formvalue == 'onecol':
	twocols = 0

try:
	formvalue = form['km'].value
except:
	formvalue = ''
if formvalue == 'usekm':
	msw = 0

try:
	formvalue = form['showll'].value
except:
	formvalue = ''
if formvalue != 'showit':
	showll = 0

ch = '<font color="#ff0000"><b>'
ct = '</b></font>'
tstr = ''
tbstr = ''
tbphase = 0
xt1 = ''
xt2 = ''


# Various presets we modify, extend and use on a line by line basis
# -----------------------------------------------------------------
vtag = ' km'
if msw == 1:
	vtag = ' mi'
hha = '<font size=-4>'
hhb = '</font>'
cki = '<INPUT TYPE="checkbox" NAME="cki.[REP]" VALUE="on"[STATE]>'
pri = '<INPUT TYPE="checkbox" NAME="pri.[REP]" VALUE="on"[STATE]>'
rootcalla = '<tt><b><a href="/cgi-bin/'+rpt+'.py?fromcall=[FCALL]">'
rootcallb = '</a></b></tt>'
orderblank = '<INPUT TYPE="text" SIZE=3 MAXLENGTH=3 NAME="odb.[FCALL]" VALUE="[VAL]">'
havechecks = 0

# Here we go:
# -----------
if 1:	# how many list entries are there going to be?
	try:
		conn = sqlite3.connect(dbname)
	except:
		tstr += 'sqlite3.connect(... exception'
	else:
		try:
			c = conn.cursor()
		except:
			tstr += 'conn.cursor() exception'
		else:
			memcount = 0
			try:
				for row in c.execute('SELECT count(*) FROM members'):
					memcount = int(row[0])
			except:
				pass
			tl1 = 0
			tl2 = 0
			rc = 0
			datalist = []
# Arbitrate how many entries per column
# -------------------------------------
			if memcount > 1:
				tl2 = int(memcount / 2)
				tl1 = memcount - tl2
			else:
				tl1 = memcount
			if twocols == 0:
				tl1 = memcount
			try:
				xdist = 0
				xhead = 0
# DB phase
# --------
# This is where we look up the basic list data
# and calculate derived columns range and bearing
# -----------------------------------------------
				for row in c.execute(sql):
					alat = str(row[3])
					alon = str(row[4])
					if alat != '' and alon != '' and homelat != '' and homelon != '':
						adis = llrange(homelat,homelon,alat,alon,msw)
						abea = llbear(homelat,homelon,alat,alon)
					else:
						adis = '0.0'
						abea = '0.0'

					# checked in checkbox
					checked = 0
					try:
						formvalue = form['cki.'+str(row[1]).upper()].value
					except:
						pass
					else:
						if globalclear != 1:
							checked = 1
							havechecks = 1

					pred = 0
					try:
						formvalue = form['pri.'+str(row[1]).upper()].value
					except:
						pass
					else:
						if globalclear != 1:
							pred = 1

					# sort order box
					numb = 0
					try:
						formvalue = str(form['odb.'+str(row[1]).upper()].value)
					except:
						pass
					else:
						try:
							numb = int(formvalue)
						except:
							numb = 0
					if numb > 999 or numb < 0 or globalnn == 1:
						numb = 0
					sl = [row[0],row[1],row[2],row[3],row[4],adis,abea,checked,numb,pred]
					datalist.append(sl)

# Now we have a list containing all columns. The db could only sort
# on existing db data; but some sorts require derived data. I do
# those sorts on the list, after the DB sort:
# -----------------------------------------------------------------

# Post-sorts on metadata
# ----------------------
				if sbyd == 1:
					datalist = sorted(datalist,key=lambda zxc: float(zxc[5]))
				elif sbyh == 1:
					datalist = sorted(datalist,key=lambda zxc: float(zxc[6]))
				elif sbyn == 1:
					datalist = sorted(datalist,key=lambda zxc: int(zxc[8]))

# list phase
# ----------
# It may be that some entries were checked-in. Float those to top
# ---------------------------------------------------------------
				mdata = []
				if floatup == 1:
					for el in datalist:
						if el[7] == 1:
							mdata.append(el)
					for el in datalist:
						if el[7] == 0:
							mdata.append(el)
					datalist = mdata

# Data is arranged for display; map it
# ------------------------------------
				repper = ''
				lbrepper = ''
				if havechecks == 0:
					latc = homelat
					lonc = homelon
					repper = "['YOU',"+homelat+","+homelon+",1]"
				else:
					latc = homelat
					lonc = homelon
					tmpct = 0
					fpcount = 0
					nhit = 0
					for el in datalist:
						if el[7] == 1:
							tmpct += 1
							aline = "['"+str(el[1]).upper()+", "+el[0]+" ("+str(el[6])+")"+"',"+el[3]+","+el[4]+","+str(tmpct)+"]"
							if nhit == 1:
								aline += ",\n"
							nhit = 1
							repper = aline + repper
# This code builds the lines for the map
# --------------------------------------
							fpcount += 1
							if 1:
								polyl = "var cline"+str(fpcount)+" = [\n"
								polyl+= "   new google.maps.LatLng("+homelat+","+homelon+"),\n"
								polyl+= "   new google.maps.LatLng("+el[3]+","+el[4]+"),\n"
								polyl+= "];\n"
								polyl+= "var ccline"+str(fpcount)+" = new google.maps.Polyline({\n"
								polyl+= "   path: cline"+str(fpcount)+",\n"
								polyl+= "   geodesic: true,\n"
								if el[9] == 0:
									polyl+= "   strokeColor: '#"+cicolor+"',\n"
								else:
									polyl+= "   strokeColor: '#"+prcolor+"',\n"
								polyl+= "   strokeOpacity: 1.0,\n"
								polyl+= "   strokeWeight: "+sweight+"\n"
								polyl+= "});\n"
								polyl+= "ccline"+str(fpcount)+".setMap(map);\n"
								lbrepper += polyl
							
							if showlabs == 1:
								polyn = themarker
								polyn = polyn.replace('[HOMELATLNG]','new google.maps.LatLng('+el[3]+','+el[4]+')')
								polyn = polyn.replace('[LABELCONTENT]',str(el[1]).upper()+", "+el[0]+": "+str(el[6])+"&deg;")
								lbrepper += polyn
								
							lbrepper += '\n'

# Configure the javascript template with our specifics
# ----------------------------------------------------
				page = page.replace('[LINEBLOCK]',lbrepper)	# lines
				page = page.replace('[CENTLAT]',latc)		# latitude
				page = page.replace('[CENTLONG]',lonc)		# longitude
				page = page.replace('[POINTLIST]',repper)	# stations

# Display the table of group members, sorted and floated as requested
# -------------------------------------------------------------------
				for row in datalist:
					if tbphase == 0:
						if showll == 1:
							t = table("#","ck","pr","#","Name","Call","Location","Lat","Long","Dist","Bear")
							t.options(	lparms='align=right|||||||align=right|align=right|align=right|align=right',
										hparms='|||'+cc6+'|'+cc1+'|'+cc2+'|'+cc3+'|||'+cc4+'|'+cc5)
						else:
							t = table("#","ck","pr","#","Name","Call","Location","Dist","Bear")
							t.options(lparms='align=right|||||||align=right|align=right',
							hparms='|||'+cc6+'|'+cc1+'|'+cc2+'|'+cc3+'|'+cc4+'|'+cc5)
						tbphase = 1
						rc = 0
					rc += 1
					ea = '<tt>'+str(rc)+'</tt>'

					aname = str(row[0])
					acall = str(row[1]).upper()
					aloca = str(row[2])
					alat = str(row[3])
					alon = str(row[4])
					adist= str(row[5])
					abear= str(row[6])
					# "checked in" = 7
					anumb = str(row[8])
					# "has propagation" = 9 (use for map line color)
					
					oxb = orderblank.replace('[FCALL]',acall)
					oxb = oxb.replace('[VAL]',anumb)
					
					cpr = rootcalla.replace('[FCALL]',acall)
					cpo = rootcallb
					
					ckix = cki.replace('[REP]',acall)
					mobs = ''
					try:
						formvalue = form['cki.'+acall].value
					except:
						pass
					else:
						if formvalue == 'on' and globalclear == 0:
							mobs = ' CHECKED'
					ckix = ckix.replace('[STATE]',mobs)

					prix = pri.replace('[REP]',acall)
					prbs = ''
					try:
						formvalue = form['pri.'+acall].value
					except:
						pass
					else:
						if formvalue == 'on' and globalclear == 0:
							prbs = ' CHECKED'
					prix = prix.replace('[STATE]',prbs)
# ---------------------------------------------------------
# Actually add lines to the table:
# ---------------------------------------------------------
					if showll == 1:
						tbstr += t.line(ea,ckix,prix,oxb,aname,cpr+acall+cpo,aloca,hha+alat+hhb,hha+alon+hhb,'<b><tt>'+adist+vtag+'</tt></b>','<b><tt>'+abear+'&deg;</tt></b>')
					else:
						tbstr += t.line(ea,ckix,prix,oxb,aname,cpr+acall+cpo,aloca,'<b><tt>'+adist+vtag+'</tt></b>','<b><tt>'+abear+'&deg;</tt></b>')
#
# ---------------------------------------------------------
					if rc == tl1:
						tbstr += t.finish()
						xt1 += tbstr
						tbphase += 1
						if tbphase == 2:
							if tl2 > 0:
								if showll == 1:
									t = table("#","ck","pr","#","Name","Call","Location","Lat","Long","Dist","Bear")
									t.options(	lparms='align=right|||||||align=right|align=right|align=right|align=right',
												hparms='|||'+cc6+'|'+cc1+'|'+cc2+'|'+cc3+'|||'+cc4+'|'+cc5)
								else:
									t = table("#","ck","pr","#","Name","Call","Location","Dist","Bear")
									t.options(lparms='align=right|||||||align=right|align=right',
									hparms='|||'+cc6+'|'+cc1+'|'+cc2+'|'+cc3+'|'+cc4+'|'+cc5)
								tbstr = ''
								tbphase = 3
					if tl2 != 0 and rc == memcount:
						tbstr += t.finish()
						xt2 += tbstr
			except Exception as inst:
				tstr += 'c.execute(main SELECT... exception'+' '+str(inst)
			c.close()

# This is the template for the actual list:
# -----------------------------------------
twoc = """
<table>
<tr>
<td valign="top">[TDS1]</td>
<td width=25> </td>
<td valign="top">[TDS2]</td>
</tr>
</table>
"""

twoc = twoc.replace('[TDS1]',xt1) # column one, almost always present
twoc = twoc.replace('[TDS2]',xt2) # column two, present sometimes
tstr += twoc

# Bunch of template configuration
# -------------------------------
page = page.replace('[REPLACE]',tstr)
page = page.replace('[HLAT]',homelat)
page = page.replace('[HLON]',homelon)
page = page.replace('[CBYCALL]',cbt)
page = page.replace('[CBYNAME]',cbi)
page = page.replace('[CBYLOCATION]',cbs)
page = page.replace('[CBYHEADING]',cbp)
page = page.replace('[CBYDISTANCE]',cbx)
page = page.replace('[CBYNUMBER]',cbv)
page = page.replace('[VALIDATION]',vreplace)
page = page.replace('[FILLMELAT]',overlat)
page = page.replace('[FILLMELON]',overlon)
page = page.replace('[FILLMECAL]',overcall)

# These are conditional configurations based on user choices
# ----------------------------------------------------------
bleep = ''
if msw == 0:
	bleep = ' CHECKED'
page = page.replace('[KMMI]',bleep)

bleep = ''
if twocols == 0:
	bleep = ' CHECKED'
page = page.replace('[ONEC]',bleep)

bleep = ''
if showll == 1:
	bleep = ' CHECKED'
page = page.replace('[SHOWLL]',bleep)

bleep = ''
if floatup == 1:
	bleep = ' CHECKED'
page = page.replace('[SHOWFU]',bleep)

bleep = ''
if showlabs == 1:
	bleep = ' CHECKED'
page = page.replace('[SHOWLABS]',bleep)

# Finally, if there are diagnostics, we show them
# -----------------------------------------------
page = page.replace('[DIAG]',thediag) # thediag

sys.stdout.write(hdr)	# nudge the browser
sys.stdout.write(page)	# send the page
sys.stdout.flush()		# ensure it's all sent

raise SystemExit		# and call it quits
